<?php
/*
 * @copyright   Leyun internet Technology(Shanghai)Co.,Ltd
 * @license     http://www.dzzoffice.com/licenses/license.txt
 * @package     DzzOffice
 * @version     DzzOffice beta 2013.12.01
 * @link        http://www.dzzoffice.com
 * @author      zyx(zyx@dzz.cc)
 */

class perm_check{  
    
  	function getuserPerm(){
		global $_G;
		$perm= DB::result_first("select perm from %t where uid=%d",array('user_field',$_G['uid']));
		$groupperm=$_G['group']['perm'];
		if($perm<1) return intval($_G['group']['perm']);
		else return $perm;
	}
	function getPerm($fid, $bz=''){
		global $_G;
		static $i=0;
		$i++;
		if($i>20){ //防死循环，如果循环20次以上，直接退出；
			return false;
		}
		if($folder=C::t('folder')->fetch($fid)){
			if($folder['gid']){
				$moderators=C::t('organization_user')->fetch_moderators_by_orgid($folder['gid'],true);
				if(in_array($_G['uid'],$moderators)) return 5;
				$perm=intval($folder['perm']);
				$power=new perm_binPerm($perm);
				if($power->isPower('flag')){//不继承，使用此权限
					return $perm;
				}else{ //继承上级，查找上级
					if($folder['pfid']>0 && $folder['pfid']!=$folder['fid']){ //有上级目录
						return self::getPerm($folder['pfid']);
					}else{   //其他的情况使用
						return 3;
					}
				}
			}else{
				return self::getuserPerm();
			}
		}else{
			return 3;
		}
	}
	function getPerm1($fid, $bz=''){
		global $_G;
		static $i=0;
		$i++;
		if($i>20){ //防死循环，如果循环20次以上，直接退出；
			return false;
		}
		if($folder=C::t('folder')->fetch($fid)){
			if($folder['gid']){
				$perm=intval($folder['perm']);
				$power=new perm_binPerm($perm);
				if($power->isPower('flag')){//不继承，使用此权限
					return $perm;
				}else{ //继承上级，查找上级
					if($folder['pfid']>0 && $folder['pfid']!=$folder['fid']){ //有上级目录
						return self::getPerm1($folder['pfid']);
					}else{   //其他的情况使用
						return 3;
					}
				}
			}else{
				return self::getuserPerm();
			}
		}else{
			return 3;
		}
	}
	
	function userPerm($fid,$action){ //判断容器有没有指定的权限
		global $_G;
		if($_G['adminid']==1){ //是管理员
			return true;
		}
		
		if(!$_G['uid']){ //如果不是登录用户，返回false;
			return false;
		}
		if($action=='admin') return true;
		if($action=='download' || $action=='saveto' || $action=='copy' ) return true;
		$perm=self::getuserPerm();
		if($perm<5){
			if($action=='view') return true;
			else return false;
		}
		/*if($perm>0){
			$power=new perm_binPerm($perm);
			return $power->isPower($action);
		}*/
		return true;
	}
	function groupPerm($fid,$action,$gid){ //判断容器有没有指定的权限
		global $_G;
		$moderators=C::t('organization_user')->fetch_moderators_by_orgid($gid,true);
		$members=C::t('organization_user')->fetch_uids_by_orgid($gid);
		if(in_array($_G['uid'],$moderators)) $ismoderator=true;
		if($action=='admin' && $ismoderator)  return true;
		if($ismoderator){ //是机构管理员
			return true;
		}
		if(!in_array($_G['uid'],$members)) return false;
		if($action=='download' || $action=='saveto' || $action=='copy' ) return true;
		$perm=self::getPerm($fid);
		/*if($perm>0){
			$power=new perm_binPerm($perm);
			return $power->isPower($action);
		}*/
		if($perm<5) {
			if($action=='view') return true;
			else return false;
		}
		return true;
	}
	
	//$arr=array('uid','gid','desktop');其中这几项必须
	function checkperm($action,$arr,$bz=''){ //检查某个图标是否有权限;
		global $_G;
		if($_G['uid']<1){ //游客没有权限
			return false;
		}
		if($bz){
			return self::checkperm_Container($arr['pfid'],$action,$bz);
		}else{
			//首先判断ico的超级权限；
			if(!perm_FileSPerm::isPower($arr['sperm'],$action)) return false;
		
			if($folder=C::t('folder')->fetch_by_fid($arr['pfid'])){
				//首先判断目录的超级权限；
				if(!perm_FolderSPerm::isPower($folder['fsperm'],$action)) return false;
			}
			if($_G['adminid']==1) return true; //网站管理员 有权限;
			
			if( self::checkperm_Container($arr['pfid'],$action,$bz)){ //判断容器权限通过时
				
				if($arr['gid']>0 && ($action=='delete' || $action=='edit')){//删除和编辑权限特殊处理：是群管理员有权限，是自己的文件有权限
						$moderators=C::t('organization_user')->fetch_moderators_by_orgid($gid);//获取群组管理员数组
						if(isset($moderators[$_G['uid']]) || $_G['uid']==$arr['uid']) return true;
						else return false;
				}else{
					return true;
				}
			}
		}
	}
	function checkperm_Container($pfid,$action='',$bz=''){ //检查容器是否有权限操作;
		global $_G;
		
		if($_G['uid']<1){ //游客没有权限
			return false;
		}
		if($bz){
			if(!perm_FolderSPerm::isPower(prem_FolderSPerm::flagPower($bz),$action)) return false;
			return true;
		}else{
			if($folder=C::t('folder')->fetch_by_fid($pfid)){
				
				//首先判断目录的超级权限；
				if(!perm_FolderSPerm::isPower($folder['fsperm'],$action)) return false;
				//默认目录只有管理员有权限改变排列
				//if($action=='admin' && $_G['adminid']!=1 && $folder['flag']!='folder') return false;
			}else{ //目录不存在，没有权限操作
				return false;
			}
			if($_G['adminid']==1) return true; //网址管理员 有权限;
			
			/*if($folder['perm']<5){
				if(in_array($_G['uid'],$folder['moderators'])){
					return true;
				}else return false;
			}else{
				return true;
			}*/
			if($folder['gid']){
				return self::groupPerm($pfid,$action,$folder['gid']);
			}else{
				return self::userPerm($pfid,$action);
			}
		}
	}
}  
?>
